/* Generated by CIL v. 1.5.1 */
/* print_CIL_Input is false */

#line 20 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned char __u8;
#line 23 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned short __u16;
#line 26 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned int __u32;
#line 30 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned long long __u64;
#line 15 "include/asm-generic/int-ll64.h"
typedef signed char s8;
#line 16 "include/asm-generic/int-ll64.h"
typedef unsigned char u8;
#line 19 "include/asm-generic/int-ll64.h"
typedef unsigned short u16;
#line 21 "include/asm-generic/int-ll64.h"
typedef int s32;
#line 22 "include/asm-generic/int-ll64.h"
typedef unsigned int u32;
#line 24 "include/asm-generic/int-ll64.h"
typedef long long s64;
#line 25 "include/asm-generic/int-ll64.h"
typedef unsigned long long u64;
#line 14 "./include/uapi/asm-generic/posix_types.h"
typedef long __kernel_long_t;
#line 15 "./include/uapi/asm-generic/posix_types.h"
typedef unsigned long __kernel_ulong_t;
#line 48 "./include/uapi/asm-generic/posix_types.h"
typedef unsigned int __kernel_uid32_t;
#line 49 "./include/uapi/asm-generic/posix_types.h"
typedef unsigned int __kernel_gid32_t;
#line 71 "./include/uapi/asm-generic/posix_types.h"
typedef __kernel_ulong_t __kernel_size_t;
#line 72 "./include/uapi/asm-generic/posix_types.h"
typedef __kernel_long_t __kernel_ssize_t;
#line 87 "./include/uapi/asm-generic/posix_types.h"
typedef long long __kernel_loff_t;
#line 229 "include/linux/compiler.h"
struct kernel_symbol {
   unsigned long value ;
   char const   *name ;
};
#line 33 "include/linux/export.h"
struct module;
#line 12 "include/linux/types.h"
typedef __u32 __kernel_dev_t;
#line 15 "include/linux/types.h"
typedef __kernel_dev_t dev_t;
#line 18 "include/linux/types.h"
typedef unsigned short umode_t;
#line 29 "include/linux/types.h"
typedef _Bool bool;
#line 31 "include/linux/types.h"
typedef __kernel_uid32_t uid_t;
#line 32 "include/linux/types.h"
typedef __kernel_gid32_t gid_t;
#line 45 "include/linux/types.h"
typedef __kernel_loff_t loff_t;
#line 54 "include/linux/types.h"
typedef __kernel_size_t size_t;
#line 59 "include/linux/types.h"
typedef __kernel_ssize_t ssize_t;
#line 152 "include/linux/types.h"
typedef u64 dma_addr_t;
#line 162 "include/linux/types.h"
typedef u64 phys_addr_t;
#line 167 "include/linux/types.h"
typedef phys_addr_t resource_size_t;
#line 177 "include/linux/types.h"
struct __anonstruct_atomic_t_6 {
   int counter ;
};
#line 177 "include/linux/types.h"
typedef struct __anonstruct_atomic_t_6 atomic_t;
#line 182 "include/linux/types.h"
struct __anonstruct_atomic64_t_7 {
   long counter ;
};
#line 182 "include/linux/types.h"
typedef struct __anonstruct_atomic64_t_7 atomic64_t;
#line 183 "include/linux/types.h"
struct list_head {
   struct list_head *next ;
   struct list_head *prev ;
};
#line 188
struct hlist_node;
#line 192 "include/linux/types.h"
struct hlist_node {
   struct hlist_node *next ;
   struct hlist_node **pprev ;
};
#line 203 "include/linux/types.h"
struct callback_head {
   struct callback_head *next ;
   void (*func)(struct callback_head * ) ;
};
#line 12 "./arch/x86/include/asm/pgtable_64_types.h"
typedef unsigned long pteval_t;
#line 15 "./arch/x86/include/asm/pgtable_64_types.h"
typedef unsigned long pgdval_t;
#line 16 "./arch/x86/include/asm/pgtable_64_types.h"
typedef unsigned long pgprotval_t;
#line 18 "./arch/x86/include/asm/pgtable_64_types.h"
struct __anonstruct_pte_t_11 {
   pteval_t pte ;
};
#line 18 "./arch/x86/include/asm/pgtable_64_types.h"
typedef struct __anonstruct_pte_t_11 pte_t;
#line 20 "./arch/x86/include/asm/pgtable_64_types.h"
struct pgprot {
   pgprotval_t pgprot ;
};
#line 218 "./arch/x86/include/asm/pgtable_types.h"
typedef struct pgprot pgprot_t;
#line 220 "./arch/x86/include/asm/pgtable_types.h"
struct __anonstruct_pgd_t_12 {
   pgdval_t pgd ;
};
#line 220 "./arch/x86/include/asm/pgtable_types.h"
typedef struct __anonstruct_pgd_t_12 pgd_t;
#line 361
struct page;
#line 361 "./arch/x86/include/asm/pgtable_types.h"
typedef struct page *pgtable_t;
#line 372
struct file;
#line 385
struct seq_file;
#line 425
struct mm_struct;
#line 426
struct task_struct;
#line 427
struct cpumask;
#line 20 "./arch/x86/include/asm/spinlock_types.h"
struct qspinlock {
   atomic_t val ;
};
#line 33 "include/asm-generic/qspinlock_types.h"
typedef struct qspinlock arch_spinlock_t;
#line 131 "include/linux/init.h"
typedef void (*ctor_fn_t)(void);
#line 234 "include/linux/printk.h"
struct _ddebug {
   char const   *modname ;
   char const   *function ;
   char const   *filename ;
   char const   *format ;
   unsigned int lineno : 18 ;
   unsigned char flags ;
};
#line 48 "include/linux/dynamic_debug.h"
struct device;
#line 432 "include/linux/printk.h"
struct completion;
#line 687 "include/linux/list.h"
struct lockdep_map;
#line 328 "include/linux/bitmap.h"
struct bug_entry {
   int bug_addr_disp ;
   int file_disp ;
   unsigned short line ;
   unsigned short flags ;
};
#line 102 "include/linux/bug.h"
struct cpumask {
   unsigned long bits[128U] ;
};
#line 652 "include/linux/cpumask.h"
typedef struct cpumask *cpumask_var_t;
#line 170 "./arch/x86/include/asm/processor.h"
struct seq_operations;
#line 23 "include/asm-generic/atomic-long.h"
typedef atomic64_t atomic_long_t;
#line 55 "include/linux/debug_locks.h"
struct stack_trace {
   unsigned int nr_entries ;
   unsigned int max_entries ;
   unsigned long *entries ;
   int skip ;
};
#line 28 "include/linux/stacktrace.h"
struct lockdep_subclass_key {
   char __one_byte ;
};
#line 53 "include/linux/lockdep.h"
struct lock_class_key {
   struct lockdep_subclass_key subkeys[8U] ;
};
#line 59 "include/linux/lockdep.h"
struct lock_class {
   struct list_head hash_entry ;
   struct list_head lock_entry ;
   struct lockdep_subclass_key *key ;
   unsigned int subclass ;
   unsigned int dep_gen_id ;
   unsigned long usage_mask ;
   struct stack_trace usage_traces[13U] ;
   struct list_head locks_after ;
   struct list_head locks_before ;
   unsigned int version ;
   unsigned long ops ;
   char const   *name ;
   int name_version ;
   unsigned long contention_point[4U] ;
   unsigned long contending_point[4U] ;
};
#line 144 "include/linux/lockdep.h"
struct lockdep_map {
   struct lock_class_key *key ;
   struct lock_class *class_cache[2U] ;
   char const   *name ;
   int cpu ;
   unsigned long ip ;
};
#line 546 "include/linux/lockdep.h"
struct raw_spinlock {
   arch_spinlock_t raw_lock ;
   unsigned int magic ;
   unsigned int owner_cpu ;
   void *owner ;
   struct lockdep_map dep_map ;
};
#line 32 "include/linux/spinlock_types.h"
typedef struct raw_spinlock raw_spinlock_t;
#line 33 "include/linux/spinlock_types.h"
struct __anonstruct____missing_field_name_31 {
   u8 __padding[24U] ;
   struct lockdep_map dep_map ;
};
#line 33 "include/linux/spinlock_types.h"
union __anonunion____missing_field_name_30 {
   struct raw_spinlock rlock ;
   struct __anonstruct____missing_field_name_31 __annonCompField16 ;
};
#line 33 "include/linux/spinlock_types.h"
struct spinlock {
   union __anonunion____missing_field_name_30 __annonCompField17 ;
};
#line 76 "include/linux/spinlock_types.h"
typedef struct spinlock spinlock_t;
#line 13 "include/linux/osq_lock.h"
struct optimistic_spin_queue {
   atomic_t tail ;
};
#line 39 "include/linux/osq_lock.h"
struct mutex {
   atomic_t count ;
   spinlock_t wait_lock ;
   struct list_head wait_list ;
   struct task_struct *owner ;
   void *magic ;
   struct lockdep_map dep_map ;
};
#line 53 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.o.c.prepared"
struct resource {
   resource_size_t start ;
   resource_size_t end ;
   char const   *name ;
   unsigned long flags ;
   struct resource *parent ;
   struct resource *sibling ;
   struct resource *child ;
};
#line 38 "include/linux/wait.h"
struct __wait_queue_head {
   spinlock_t lock ;
   struct list_head task_list ;
};
#line 43 "include/linux/wait.h"
typedef struct __wait_queue_head wait_queue_head_t;
#line 1170 "include/linux/wait.h"
struct completion {
   unsigned int done ;
   wait_queue_head_t wait ;
};
#line 437 "include/linux/jiffies.h"
union ktime {
   s64 tv64 ;
};
#line 41 "include/linux/ktime.h"
typedef union ktime ktime_t;
#line 1120 "include/linux/rcupdate.h"
union __anonunion____missing_field_name_46 {
   unsigned long bitmap[4U] ;
   struct callback_head callback_head ;
};
#line 1120 "include/linux/rcupdate.h"
struct idr_layer {
   int prefix ;
   int layer ;
   struct idr_layer *ary[256U] ;
   int count ;
   union __anonunion____missing_field_name_46 __annonCompField19 ;
};
#line 41 "include/linux/idr.h"
struct idr {
   struct idr_layer *hint ;
   struct idr_layer *top ;
   int layers ;
   int cur ;
   spinlock_t lock ;
   int id_free_cnt ;
   struct idr_layer *id_free ;
};
#line 124 "include/linux/idr.h"
struct ida_bitmap {
   long nr_busy ;
   unsigned long bitmap[15U] ;
};
#line 153 "include/linux/idr.h"
struct ida {
   struct idr idr ;
   struct ida_bitmap *free_bitmap ;
};
#line 185 "include/linux/idr.h"
struct rb_node {
   unsigned long __rb_parent_color ;
   struct rb_node *rb_right ;
   struct rb_node *rb_left ;
};
#line 41 "include/linux/rbtree.h"
struct rb_root {
   struct rb_node *rb_node ;
};
#line 99
struct vm_area_struct;
#line 102
struct kernfs_open_node;
#line 103
struct kernfs_iattrs;
#line 126
struct kernfs_root;
#line 126 "include/linux/rbtree.h"
struct kernfs_elem_dir {
   unsigned long subdirs ;
   struct rb_root children ;
   struct kernfs_root *root ;
};
#line 85 "include/linux/kernfs.h"
struct kernfs_node;
#line 85 "include/linux/kernfs.h"
struct kernfs_elem_symlink {
   struct kernfs_node *target_kn ;
};
#line 89
struct kernfs_ops;
#line 89 "include/linux/kernfs.h"
struct kernfs_elem_attr {
   struct kernfs_ops  const  *ops ;
   struct kernfs_open_node *open ;
   loff_t size ;
   struct kernfs_node *notify_next ;
};
#line 96 "include/linux/kernfs.h"
union __anonunion____missing_field_name_51 {
   struct kernfs_elem_dir dir ;
   struct kernfs_elem_symlink symlink ;
   struct kernfs_elem_attr attr ;
};
#line 96 "include/linux/kernfs.h"
struct kernfs_node {
   atomic_t count ;
   atomic_t active ;
   struct lockdep_map dep_map ;
   struct kernfs_node *parent ;
   char const   *name ;
   struct rb_node rb ;
   void const   *ns ;
   unsigned int hash ;
   union __anonunion____missing_field_name_51 __annonCompField20 ;
   void *priv ;
   unsigned short flags ;
   umode_t mode ;
   unsigned int ino ;
   struct kernfs_iattrs *iattr ;
};
#line 138 "include/linux/kernfs.h"
struct kernfs_syscall_ops {
   int (*remount_fs)(struct kernfs_root * , int * , char * ) ;
   int (*show_options)(struct seq_file * , struct kernfs_root * ) ;
   int (*mkdir)(struct kernfs_node * , char const   * , umode_t  ) ;
   int (*rmdir)(struct kernfs_node * ) ;
   int (*rename)(struct kernfs_node * , struct kernfs_node * , char const   * ) ;
};
#line 155 "include/linux/kernfs.h"
struct kernfs_root {
   struct kernfs_node *kn ;
   unsigned int flags ;
   struct ida ino_ida ;
   struct kernfs_syscall_ops *syscall_ops ;
   struct list_head supers ;
   wait_queue_head_t deactivate_waitq ;
};
#line 171
struct vm_operations_struct;
#line 171 "include/linux/kernfs.h"
struct kernfs_open_file {
   struct kernfs_node *kn ;
   struct file *file ;
   void *priv ;
   struct mutex mutex ;
   int event ;
   struct list_head list ;
   char *prealloc_buf ;
   size_t atomic_write_len ;
   bool mmapped ;
   struct vm_operations_struct  const  *vm_ops ;
};
#line 188 "include/linux/kernfs.h"
struct kernfs_ops {
   int (*seq_show)(struct seq_file * , void * ) ;
   void *(*seq_start)(struct seq_file * , loff_t * ) ;
   void *(*seq_next)(struct seq_file * , void * , loff_t * ) ;
   void (*seq_stop)(struct seq_file * , void * ) ;
   ssize_t (*read)(struct kernfs_open_file * , char * , size_t  , loff_t  ) ;
   size_t atomic_write_len ;
   bool prealloc ;
   ssize_t (*write)(struct kernfs_open_file * , char * , size_t  , loff_t  ) ;
   int (*mmap)(struct kernfs_open_file * , struct vm_area_struct * ) ;
   struct lock_class_key lockdep_key ;
};
#line 477
struct sock;
#line 478
struct kobject;
#line 479
enum kobj_ns_type {
    KOBJ_NS_TYPE_NONE = 0,
    KOBJ_NS_TYPE_NET = 1,
    KOBJ_NS_TYPES = 2
} ;
#line 485 "include/linux/kernfs.h"
struct kobj_ns_type_operations {
   enum kobj_ns_type type ;
   bool (*current_may_mount)(void) ;
   void *(*grab_current_ns)(void) ;
   void const   *(*netlink_ns)(struct sock * ) ;
   void const   *(*initial_ns)(void) ;
   void (*drop_ns)(void * ) ;
};
#line 83 "include/linux/highuid.h"
struct user_namespace;
#line 22 "include/linux/uidgid.h"
struct __anonstruct_kuid_t_52 {
   uid_t val ;
};
#line 22 "include/linux/uidgid.h"
typedef struct __anonstruct_kuid_t_52 kuid_t;
#line 27 "include/linux/uidgid.h"
struct __anonstruct_kgid_t_53 {
   gid_t val ;
};
#line 27 "include/linux/uidgid.h"
typedef struct __anonstruct_kgid_t_53 kgid_t;
#line 36 "include/linux/stat.h"
struct bin_attribute;
#line 37 "include/linux/stat.h"
struct attribute {
   char const   *name ;
   umode_t mode ;
   bool ignore_lockdep ;
   struct lock_class_key *key ;
   struct lock_class_key skey ;
};
#line 37 "include/linux/sysfs.h"
struct attribute_group {
   char const   *name ;
   umode_t (*is_visible)(struct kobject * , struct attribute * , int  ) ;
   struct attribute **attrs ;
   struct bin_attribute **bin_attrs ;
};
#line 82 "include/linux/sysfs.h"
struct bin_attribute {
   struct attribute attr ;
   size_t size ;
   void *private ;
   ssize_t (*read)(struct file * , struct kobject * , struct bin_attribute * , char * ,
                   loff_t  , size_t  ) ;
   ssize_t (*write)(struct file * , struct kobject * , struct bin_attribute * , char * ,
                    loff_t  , size_t  ) ;
   int (*mmap)(struct file * , struct kobject * , struct bin_attribute * , struct vm_area_struct * ) ;
};
#line 155 "include/linux/sysfs.h"
struct sysfs_ops {
   ssize_t (*show)(struct kobject * , struct attribute * , char * ) ;
   ssize_t (*store)(struct kobject * , struct attribute * , char const   * , size_t  ) ;
};
#line 509 "include/linux/sysfs.h"
struct kref {
   atomic_t refcount ;
};
#line 172 "include/linux/kref.h"
struct timer_list {
   struct hlist_node entry ;
   unsigned long expires ;
   void (*function)(unsigned long  ) ;
   unsigned long data ;
   u32 flags ;
   int slack ;
   int start_pid ;
   void *start_site ;
   char start_comm[16U] ;
   struct lockdep_map lockdep_map ;
};
#line 259 "include/linux/timer.h"
struct workqueue_struct;
#line 260
struct work_struct;
#line 54 "include/linux/workqueue.h"
struct work_struct {
   atomic_long_t data ;
   struct list_head entry ;
   void (*func)(struct work_struct * ) ;
   struct lockdep_map lockdep_map ;
};
#line 107 "include/linux/workqueue.h"
struct delayed_work {
   struct work_struct work ;
   struct timer_list timer ;
   struct workqueue_struct *wq ;
   int cpu ;
};
#line 52 "include/linux/kobject.h"
struct kset;
#line 52
struct kobj_type;
#line 52 "include/linux/kobject.h"
struct kobject {
   char const   *name ;
   struct list_head entry ;
   struct kobject *parent ;
   struct kset *kset ;
   struct kobj_type *ktype ;
   struct kernfs_node *sd ;
   struct kref kref ;
   struct delayed_work release ;
   unsigned char state_initialized : 1 ;
   unsigned char state_in_sysfs : 1 ;
   unsigned char state_add_uevent_sent : 1 ;
   unsigned char state_remove_uevent_sent : 1 ;
   unsigned char uevent_suppress : 1 ;
};
#line 114 "include/linux/kobject.h"
struct kobj_type {
   void (*release)(struct kobject * ) ;
   struct sysfs_ops  const  *sysfs_ops ;
   struct attribute **default_attrs ;
   struct kobj_ns_type_operations  const  *(*child_ns_type)(struct kobject * ) ;
   void const   *(*namespace)(struct kobject * ) ;
};
#line 122 "include/linux/kobject.h"
struct kobj_uevent_env {
   char *argv[3U] ;
   char *envp[32U] ;
   int envp_idx ;
   char buf[2048U] ;
   int buflen ;
};
#line 130 "include/linux/kobject.h"
struct kset_uevent_ops {
   int (* const  filter)(struct kset * , struct kobject * ) ;
   char const   *(* const  name)(struct kset * , struct kobject * ) ;
   int (* const  uevent)(struct kset * , struct kobject * , struct kobj_uevent_env * ) ;
};
#line 147 "include/linux/kobject.h"
struct kset {
   struct list_head list ;
   spinlock_t list_lock ;
   struct kobject kobj ;
   struct kset_uevent_ops  const  *uevent_ops ;
};
#line 222
struct klist_node;
#line 37 "include/linux/klist.h"
struct klist_node {
   void *n_klist ;
   struct list_head n_node ;
   struct kref n_ref ;
};
#line 521 "include/linux/nodemask.h"
struct seq_file {
   char *buf ;
   size_t size ;
   size_t from ;
   size_t count ;
   size_t pad_until ;
   loff_t index ;
   loff_t read_pos ;
   u64 version ;
   struct mutex lock ;
   struct seq_operations  const  *op ;
   int poll_event ;
   struct user_namespace *user_ns ;
   void *private ;
};
#line 35 "include/linux/seq_file.h"
struct seq_operations {
   void *(*start)(struct seq_file * , loff_t * ) ;
   void (*stop)(struct seq_file * , void * ) ;
   void *(*next)(struct seq_file * , void * , loff_t * ) ;
   int (*show)(struct seq_file * , void * ) ;
};
#line 187
struct pinctrl;
#line 188
struct pinctrl_state;
#line 194 "include/linux/pinctrl/consumer.h"
struct dev_pin_info {
   struct pinctrl *p ;
   struct pinctrl_state *default_state ;
   struct pinctrl_state *sleep_state ;
   struct pinctrl_state *idle_state ;
};
#line 58 "include/linux/pm.h"
struct pm_message {
   int event ;
};
#line 64 "include/linux/pm.h"
typedef struct pm_message pm_message_t;
#line 65 "include/linux/pm.h"
struct dev_pm_ops {
   int (*prepare)(struct device * ) ;
   void (*complete)(struct device * ) ;
   int (*suspend)(struct device * ) ;
   int (*resume)(struct device * ) ;
   int (*freeze)(struct device * ) ;
   int (*thaw)(struct device * ) ;
   int (*poweroff)(struct device * ) ;
   int (*restore)(struct device * ) ;
   int (*suspend_late)(struct device * ) ;
   int (*resume_early)(struct device * ) ;
   int (*freeze_late)(struct device * ) ;
   int (*thaw_early)(struct device * ) ;
   int (*poweroff_late)(struct device * ) ;
   int (*restore_early)(struct device * ) ;
   int (*suspend_noirq)(struct device * ) ;
   int (*resume_noirq)(struct device * ) ;
   int (*freeze_noirq)(struct device * ) ;
   int (*thaw_noirq)(struct device * ) ;
   int (*poweroff_noirq)(struct device * ) ;
   int (*restore_noirq)(struct device * ) ;
   int (*runtime_suspend)(struct device * ) ;
   int (*runtime_resume)(struct device * ) ;
   int (*runtime_idle)(struct device * ) ;
};
#line 320
enum rpm_status {
    RPM_ACTIVE = 0,
    RPM_RESUMING = 1,
    RPM_SUSPENDED = 2,
    RPM_SUSPENDING = 3
} ;
#line 327
enum rpm_request {
    RPM_REQ_NONE = 0,
    RPM_REQ_IDLE = 1,
    RPM_REQ_SUSPEND = 2,
    RPM_REQ_AUTOSUSPEND = 3,
    RPM_REQ_RESUME = 4
} ;
#line 335
struct wakeup_source;
#line 336
struct wake_irq;
#line 338 "include/linux/pm.h"
struct pm_subsys_data {
   spinlock_t lock ;
   unsigned int refcount ;
   struct list_head clock_list ;
};
#line 553
struct dev_pm_qos;
#line 553 "include/linux/pm.h"
struct dev_pm_info {
   pm_message_t power_state ;
   unsigned char can_wakeup : 1 ;
   unsigned char async_suspend : 1 ;
   bool is_prepared ;
   bool is_suspended ;
   bool is_noirq_suspended ;
   bool is_late_suspended ;
   bool ignore_children ;
   bool early_init ;
   bool direct_complete ;
   spinlock_t lock ;
   struct list_head entry ;
   struct completion completion ;
   struct wakeup_source *wakeup ;
   bool wakeup_path ;
   bool syscore ;
   struct timer_list suspend_timer ;
   unsigned long timer_expires ;
   struct work_struct work ;
   wait_queue_head_t wait_queue ;
   struct wake_irq *wakeirq ;
   atomic_t usage_count ;
   atomic_t child_count ;
   unsigned char disable_depth : 3 ;
   unsigned char idle_notification : 1 ;
   unsigned char request_pending : 1 ;
   unsigned char deferred_resume : 1 ;
   unsigned char run_wake : 1 ;
   unsigned char runtime_auto : 1 ;
   unsigned char no_callbacks : 1 ;
   unsigned char irq_safe : 1 ;
   unsigned char use_autosuspend : 1 ;
   unsigned char timer_autosuspends : 1 ;
   unsigned char memalloc_noio : 1 ;
   enum rpm_request request ;
   enum rpm_status runtime_status ;
   int runtime_error ;
   int autosuspend_delay ;
   unsigned long last_busy ;
   unsigned long active_jiffies ;
   unsigned long suspended_jiffies ;
   unsigned long accounting_timestamp ;
   struct pm_subsys_data *subsys_data ;
   void (*set_latency_tolerance)(struct device * , s32  ) ;
   struct dev_pm_qos *qos ;
};
#line 615 "include/linux/pm.h"
struct dev_pm_domain {
   struct dev_pm_ops ops ;
   void (*detach)(struct device * , bool  ) ;
   int (*activate)(struct device * ) ;
   void (*sync)(struct device * ) ;
   void (*dismiss)(struct device * ) ;
};
#line 796 "include/linux/mmzone.h"
struct rw_semaphore;
#line 797 "include/linux/mmzone.h"
struct rw_semaphore {
   long count ;
   struct list_head wait_list ;
   raw_spinlock_t wait_lock ;
   struct optimistic_spin_queue osq ;
   struct task_struct *owner ;
   struct lockdep_map dep_map ;
};
#line 24 "./arch/x86/include/asm/mmu.h"
struct __anonstruct_mm_context_t_121 {
   void *ldt ;
   int size ;
   unsigned short ia32_compat ;
   struct mutex lock ;
   void *vdso ;
   atomic_t perf_rdpmc_allowed ;
};
#line 24 "./arch/x86/include/asm/mmu.h"
typedef struct __anonstruct_mm_context_t_121 mm_context_t;
#line 428 "include/linux/gfp.h"
struct dma_map_ops;
#line 428 "include/linux/gfp.h"
struct dev_archdata {
   struct dma_map_ops *dma_ops ;
   void *iommu ;
};
#line 14 "./arch/x86/include/asm/device.h"
struct device_private;
#line 15
struct device_driver;
#line 16
struct driver_private;
#line 17
struct class;
#line 18
struct subsys_private;
#line 19
struct bus_type;
#line 20
struct device_node;
#line 21
struct fwnode_handle;
#line 22
struct iommu_ops;
#line 23
struct iommu_group;
#line 61 "include/linux/device.h"
struct device_attribute;
#line 61 "include/linux/device.h"
struct bus_type {
   char const   *name ;
   char const   *dev_name ;
   struct device *dev_root ;
   struct device_attribute *dev_attrs ;
   struct attribute_group  const  **bus_groups ;
   struct attribute_group  const  **dev_groups ;
   struct attribute_group  const  **drv_groups ;
   int (*match)(struct device * , struct device_driver * ) ;
   int (*uevent)(struct device * , struct kobj_uevent_env * ) ;
   int (*probe)(struct device * ) ;
   int (*remove)(struct device * ) ;
   void (*shutdown)(struct device * ) ;
   int (*online)(struct device * ) ;
   int (*offline)(struct device * ) ;
   int (*suspend)(struct device * , pm_message_t  ) ;
   int (*resume)(struct device * ) ;
   struct dev_pm_ops  const  *pm ;
   struct iommu_ops  const  *iommu_ops ;
   struct subsys_private *p ;
   struct lock_class_key lock_key ;
};
#line 139
struct device_type;
#line 197
enum probe_type {
    PROBE_DEFAULT_STRATEGY = 0,
    PROBE_PREFER_ASYNCHRONOUS = 1,
    PROBE_FORCE_SYNCHRONOUS = 2
} ;
#line 203
struct of_device_id;
#line 203
struct acpi_device_id;
#line 203 "include/linux/device.h"
struct device_driver {
   char const   *name ;
   struct bus_type *bus ;
   struct module *owner ;
   char const   *mod_name ;
   bool suppress_bind_attrs ;
   enum probe_type probe_type ;
   struct of_device_id  const  *of_match_table ;
   struct acpi_device_id  const  *acpi_match_table ;
   int (*probe)(struct device * ) ;
   int (*remove)(struct device * ) ;
   void (*shutdown)(struct device * ) ;
   int (*suspend)(struct device * , pm_message_t  ) ;
   int (*resume)(struct device * ) ;
   struct attribute_group  const  **groups ;
   struct dev_pm_ops  const  *pm ;
   struct driver_private *p ;
};
#line 353
struct class_attribute;
#line 353 "include/linux/device.h"
struct class {
   char const   *name ;
   struct module *owner ;
   struct class_attribute *class_attrs ;
   struct attribute_group  const  **dev_groups ;
   struct kobject *dev_kobj ;
   int (*dev_uevent)(struct device * , struct kobj_uevent_env * ) ;
   char *(*devnode)(struct device * , umode_t * ) ;
   void (*class_release)(struct class * ) ;
   void (*dev_release)(struct device * ) ;
   int (*suspend)(struct device * , pm_message_t  ) ;
   int (*resume)(struct device * ) ;
   struct kobj_ns_type_operations  const  *ns_type ;
   void const   *(*namespace)(struct device * ) ;
   struct dev_pm_ops  const  *pm ;
   struct subsys_private *p ;
};
#line 446 "include/linux/device.h"
struct class_attribute {
   struct attribute attr ;
   ssize_t (*show)(struct class * , struct class_attribute * , char * ) ;
   ssize_t (*store)(struct class * , struct class_attribute * , char const   * , size_t  ) ;
};
#line 514 "include/linux/device.h"
struct device_type {
   char const   *name ;
   struct attribute_group  const  **groups ;
   int (*uevent)(struct device * , struct kobj_uevent_env * ) ;
   char *(*devnode)(struct device * , umode_t * , kuid_t * , kgid_t * ) ;
   void (*release)(struct device * ) ;
   struct dev_pm_ops  const  *pm ;
};
#line 542 "include/linux/device.h"
struct device_attribute {
   struct attribute attr ;
   ssize_t (*show)(struct device * , struct device_attribute * , char * ) ;
   ssize_t (*store)(struct device * , struct device_attribute * , char const   * ,
                    size_t  ) ;
};
#line 674 "include/linux/device.h"
struct device_dma_parameters {
   unsigned int max_segment_size ;
   unsigned long segment_boundary_mask ;
};
#line 683
struct dma_coherent_mem;
#line 683
struct cma;
#line 683 "include/linux/device.h"
struct device {
   struct device *parent ;
   struct device_private *p ;
   struct kobject kobj ;
   char const   *init_name ;
   struct device_type  const  *type ;
   struct mutex mutex ;
   struct bus_type *bus ;
   struct device_driver *driver ;
   void *platform_data ;
   void *driver_data ;
   struct dev_pm_info power ;
   struct dev_pm_domain *pm_domain ;
   struct dev_pin_info *pins ;
   int numa_node ;
   u64 *dma_mask ;
   u64 coherent_dma_mask ;
   unsigned long dma_pfn_offset ;
   struct device_dma_parameters *dma_parms ;
   struct list_head dma_pools ;
   struct dma_coherent_mem *dma_mem ;
   struct cma *cma_area ;
   struct dev_archdata archdata ;
   struct device_node *of_node ;
   struct fwnode_handle *fwnode ;
   dev_t devt ;
   u32 id ;
   spinlock_t devres_lock ;
   struct list_head devres_head ;
   struct klist_node knode_class ;
   struct class *class ;
   struct attribute_group  const  **groups ;
   void (*release)(struct device * ) ;
   struct iommu_group *iommu_group ;
   bool offline_disabled ;
   bool offline ;
};
#line 829 "include/linux/device.h"
struct wakeup_source {
   char const   *name ;
   struct list_head entry ;
   spinlock_t lock ;
   struct wake_irq *wakeirq ;
   struct timer_list timer ;
   unsigned long timer_expires ;
   ktime_t total_time ;
   ktime_t max_time ;
   ktime_t last_time ;
   ktime_t start_prevent_time ;
   ktime_t prevent_sleep_time ;
   unsigned long event_count ;
   unsigned long active_count ;
   unsigned long relax_count ;
   unsigned long expire_count ;
   unsigned long wakeup_count ;
   bool active ;
   bool autosleep_enabled ;
};
#line 13 "include/linux/mod_devicetable.h"
typedef unsigned long kernel_ulong_t;
#line 186 "include/linux/mod_devicetable.h"
struct acpi_device_id {
   __u8 id[9U] ;
   kernel_ulong_t driver_data ;
};
#line 219 "include/linux/mod_devicetable.h"
struct of_device_id {
   char name[32U] ;
   char type[32U] ;
   char compatible[128U] ;
   void const   *data ;
};
#line 620 "include/linux/mod_devicetable.h"
struct rio_device_id {
   __u16 did ;
   __u16 vid ;
   __u16 asm_did ;
   __u16 asm_vid ;
};
#line 94 "include/linux/uprobes.h"
struct xol_area;
#line 95 "include/linux/uprobes.h"
struct uprobes_state {
   struct xol_area *xol_area ;
};
#line 133
struct address_space;
#line 134
struct mem_cgroup;
#line 31 "include/linux/mm_types.h"
typedef void compound_page_dtor(struct page * );
#line 32 "include/linux/mm_types.h"
union __anonunion____missing_field_name_159 {
   struct address_space *mapping ;
   void *s_mem ;
};
#line 32 "include/linux/mm_types.h"
union __anonunion____missing_field_name_161 {
   unsigned long index ;
   void *freelist ;
   bool pfmemalloc ;
};
#line 32 "include/linux/mm_types.h"
struct __anonstruct____missing_field_name_165 {
   unsigned short inuse ;
   unsigned short objects : 15 ;
   unsigned char frozen : 1 ;
};
#line 32 "include/linux/mm_types.h"
union __anonunion____missing_field_name_164 {
   atomic_t _mapcount ;
   struct __anonstruct____missing_field_name_165 __annonCompField41 ;
   int units ;
};
#line 32 "include/linux/mm_types.h"
struct __anonstruct____missing_field_name_163 {
   union __anonunion____missing_field_name_164 __annonCompField42 ;
   atomic_t _count ;
};
#line 32 "include/linux/mm_types.h"
union __anonunion____missing_field_name_162 {
   unsigned long counters ;
   struct __anonstruct____missing_field_name_163 __annonCompField43 ;
   unsigned int active ;
};
#line 32 "include/linux/mm_types.h"
struct __anonstruct____missing_field_name_160 {
   union __anonunion____missing_field_name_161 __annonCompField40 ;
   union __anonunion____missing_field_name_162 __annonCompField44 ;
};
#line 32 "include/linux/mm_types.h"
struct __anonstruct____missing_field_name_167 {
   struct page *next ;
   int pages ;
   int pobjects ;
};
#line 32
struct slab;
#line 32 "include/linux/mm_types.h"
struct __anonstruct____missing_field_name_168 {
   compound_page_dtor *compound_dtor ;
   unsigned long compound_order ;
};
#line 32 "include/linux/mm_types.h"
union __anonunion____missing_field_name_166 {
   struct list_head lru ;
   struct __anonstruct____missing_field_name_167 __annonCompField46 ;
   struct slab *slab_page ;
   struct callback_head callback_head ;
   struct __anonstruct____missing_field_name_168 __annonCompField47 ;
   pgtable_t pmd_huge_pte ;
};
#line 32
struct kmem_cache;
#line 32 "include/linux/mm_types.h"
union __anonunion____missing_field_name_169 {
   unsigned long private ;
   spinlock_t *ptl ;
   struct kmem_cache *slab_cache ;
   struct page *first_page ;
};
#line 32 "include/linux/mm_types.h"
struct page {
   unsigned long flags ;
   union __anonunion____missing_field_name_159 __annonCompField39 ;
   struct __anonstruct____missing_field_name_160 __annonCompField45 ;
   union __anonunion____missing_field_name_166 __annonCompField48 ;
   union __anonunion____missing_field_name_169 __annonCompField49 ;
   struct mem_cgroup *mem_cgroup ;
};
#line 266 "include/linux/mm_types.h"
struct __anonstruct_shared_170 {
   struct rb_node rb ;
   unsigned long rb_subtree_last ;
};
#line 266
struct anon_vma;
#line 266
struct mempolicy;
#line 266 "include/linux/mm_types.h"
struct vm_area_struct {
   unsigned long vm_start ;
   unsigned long vm_end ;
   struct vm_area_struct *vm_next ;
   struct vm_area_struct *vm_prev ;
   struct rb_node vm_rb ;
   unsigned long rb_subtree_gap ;
   struct mm_struct *vm_mm ;
   pgprot_t vm_page_prot ;
   unsigned long vm_flags ;
   struct __anonstruct_shared_170 shared ;
   struct list_head anon_vma_chain ;
   struct anon_vma *anon_vma ;
   struct vm_operations_struct  const  *vm_ops ;
   unsigned long vm_pgoff ;
   struct file *vm_file ;
   void *vm_private_data ;
   struct mempolicy *vm_policy ;
};
#line 334 "include/linux/mm_types.h"
struct core_thread {
   struct task_struct *task ;
   struct core_thread *next ;
};
#line 340 "include/linux/mm_types.h"
struct core_state {
   atomic_t nr_threads ;
   struct core_thread dumper ;
   struct completion startup ;
};
#line 361 "include/linux/mm_types.h"
struct mm_rss_stat {
   atomic_long_t count[3U] ;
};
#line 366
struct kioctx_table;
#line 367
struct linux_binfmt;
#line 367
struct mmu_notifier_mm;
#line 367 "include/linux/mm_types.h"
struct mm_struct {
   struct vm_area_struct *mmap ;
   struct rb_root mm_rb ;
   u32 vmacache_seqnum ;
   unsigned long (*get_unmapped_area)(struct file * , unsigned long  , unsigned long  ,
                                      unsigned long  , unsigned long  ) ;
   unsigned long mmap_base ;
   unsigned long mmap_legacy_base ;
   unsigned long task_size ;
   unsigned long highest_vm_end ;
   pgd_t *pgd ;
   atomic_t mm_users ;
   atomic_t mm_count ;
   atomic_long_t nr_ptes ;
   atomic_long_t nr_pmds ;
   int map_count ;
   spinlock_t page_table_lock ;
   struct rw_semaphore mmap_sem ;
   struct list_head mmlist ;
   unsigned long hiwater_rss ;
   unsigned long hiwater_vm ;
   unsigned long total_vm ;
   unsigned long locked_vm ;
   unsigned long pinned_vm ;
   unsigned long shared_vm ;
   unsigned long exec_vm ;
   unsigned long stack_vm ;
   unsigned long def_flags ;
   unsigned long start_code ;
   unsigned long end_code ;
   unsigned long start_data ;
   unsigned long end_data ;
   unsigned long start_brk ;
   unsigned long brk ;
   unsigned long start_stack ;
   unsigned long arg_start ;
   unsigned long arg_end ;
   unsigned long env_start ;
   unsigned long env_end ;
   unsigned long saved_auxv[46U] ;
   struct mm_rss_stat rss_stat ;
   struct linux_binfmt *binfmt ;
   cpumask_var_t cpu_vm_mask_var ;
   mm_context_t context ;
   unsigned long flags ;
   struct core_state *core_state ;
   spinlock_t ioctx_lock ;
   struct kioctx_table *ioctx_table ;
   struct task_struct *owner ;
   struct file *exe_file ;
   struct mmu_notifier_mm *mmu_notifier_mm ;
   struct cpumask cpumask_allocation ;
   unsigned long numa_next_scan ;
   unsigned long numa_scan_offset ;
   int numa_scan_seq ;
   bool tlb_flush_pending ;
   struct uprobes_state uprobes_state ;
   void *bd_addr ;
};
#line 207 "include/linux/mm.h"
struct vm_fault {
   unsigned int flags ;
   unsigned long pgoff ;
   void *virtual_address ;
   struct page *cow_page ;
   struct page *page ;
   unsigned long max_pgoff ;
   pte_t *pte ;
};
#line 239 "include/linux/mm.h"
struct vm_operations_struct {
   void (*open)(struct vm_area_struct * ) ;
   void (*close)(struct vm_area_struct * ) ;
   int (*fault)(struct vm_area_struct * , struct vm_fault * ) ;
   void (*map_pages)(struct vm_area_struct * , struct vm_fault * ) ;
   int (*page_mkwrite)(struct vm_area_struct * , struct vm_fault * ) ;
   int (*pfn_mkwrite)(struct vm_area_struct * , struct vm_fault * ) ;
   int (*access)(struct vm_area_struct * , unsigned long  , void * , int  , int  ) ;
   char const   *(*name)(struct vm_area_struct * ) ;
   int (*set_policy)(struct vm_area_struct * , struct mempolicy * ) ;
   struct mempolicy *(*get_policy)(struct vm_area_struct * , unsigned long  ) ;
   struct page *(*find_special_page)(struct vm_area_struct * , unsigned long  ) ;
};
#line 2242 "include/linux/mm.h"
struct scatterlist {
   unsigned long sg_magic ;
   unsigned long page_link ;
   unsigned int offset ;
   unsigned int length ;
   dma_addr_t dma_address ;
   unsigned int dma_length ;
};
#line 34 "include/linux/dmaengine.h"
typedef s32 dma_cookie_t;
#line 41
enum dma_status {
    DMA_COMPLETE = 0,
    DMA_IN_PROGRESS = 1,
    DMA_PAUSED = 2,
    DMA_ERROR = 3
} ;
#line 65
enum dma_transfer_direction {
    DMA_MEM_TO_MEM = 0,
    DMA_MEM_TO_DEV = 1,
    DMA_DEV_TO_MEM = 2,
    DMA_DEV_TO_DEV = 3,
    DMA_TRANS_NONE = 4
} ;
#line 73 "include/linux/dmaengine.h"
struct data_chunk {
   size_t size ;
   size_t icg ;
   size_t dst_icg ;
   size_t src_icg ;
};
#line 139 "include/linux/dmaengine.h"
struct dma_interleaved_template {
   dma_addr_t src_start ;
   dma_addr_t dst_start ;
   enum dma_transfer_direction dir ;
   bool src_inc ;
   bool dst_inc ;
   bool src_sgl ;
   bool dst_sgl ;
   size_t numf ;
   size_t frame_size ;
   struct data_chunk sgl[0U] ;
};
#line 170
enum dma_ctrl_flags {
    DMA_PREP_INTERRUPT = 1,
    DMA_CTRL_ACK = 2,
    DMA_PREP_PQ_DISABLE_P = 4,
    DMA_PREP_PQ_DISABLE_Q = 8,
    DMA_PREP_CONTINUE = 16,
    DMA_PREP_FENCE = 32
} ;
#line 184
enum sum_check_flags {
    SUM_CHECK_P_RESULT = 1,
    SUM_CHECK_Q_RESULT = 2
} ;
#line 219 "include/linux/dmaengine.h"
struct __anonstruct_dma_cap_mask_t_172 {
   unsigned long bits[1U] ;
};
#line 219 "include/linux/dmaengine.h"
typedef struct __anonstruct_dma_cap_mask_t_172 dma_cap_mask_t;
#line 221 "include/linux/dmaengine.h"
struct dma_chan_percpu {
   unsigned long memcpy_count ;
   unsigned long bytes_transferred ;
};
#line 232 "include/linux/dmaengine.h"
struct dma_router {
   struct device *dev ;
   void (*route_free)(struct device * , void * ) ;
};
#line 242
struct dma_device;
#line 242
struct dma_chan_dev;
#line 242 "include/linux/dmaengine.h"
struct dma_chan {
   struct dma_device *device ;
   dma_cookie_t cookie ;
   dma_cookie_t completed_cookie ;
   int chan_id ;
   struct dma_chan_dev *dev ;
   struct list_head device_node ;
   struct dma_chan_percpu *local ;
   int client_count ;
   int table_count ;
   struct dma_router *router ;
   void *route_data ;
   void *private ;
};
#line 278 "include/linux/dmaengine.h"
struct dma_chan_dev {
   struct dma_chan *chan ;
   struct device device ;
   int dev_id ;
   atomic_t *idr_ref ;
};
#line 292
enum dma_slave_buswidth {
    DMA_SLAVE_BUSWIDTH_UNDEFINED = 0,
    DMA_SLAVE_BUSWIDTH_1_BYTE = 1,
    DMA_SLAVE_BUSWIDTH_2_BYTES = 2,
    DMA_SLAVE_BUSWIDTH_3_BYTES = 3,
    DMA_SLAVE_BUSWIDTH_4_BYTES = 4,
    DMA_SLAVE_BUSWIDTH_8_BYTES = 8,
    DMA_SLAVE_BUSWIDTH_16_BYTES = 16,
    DMA_SLAVE_BUSWIDTH_32_BYTES = 32,
    DMA_SLAVE_BUSWIDTH_64_BYTES = 64
} ;
#line 304 "include/linux/dmaengine.h"
struct dma_slave_config {
   enum dma_transfer_direction direction ;
   dma_addr_t src_addr ;
   dma_addr_t dst_addr ;
   enum dma_slave_buswidth src_addr_width ;
   enum dma_slave_buswidth dst_addr_width ;
   u32 src_maxburst ;
   u32 dst_maxburst ;
   bool device_fc ;
   unsigned int slave_id ;
};
#line 365
enum dma_residue_granularity {
    DMA_RESIDUE_GRANULARITY_DESCRIPTOR = 0,
    DMA_RESIDUE_GRANULARITY_SEGMENT = 1,
    DMA_RESIDUE_GRANULARITY_BURST = 2
} ;
#line 434 "include/linux/dmaengine.h"
struct dmaengine_unmap_data {
   u8 map_cnt ;
   u8 to_cnt ;
   u8 from_cnt ;
   u8 bidi_cnt ;
   struct device *dev ;
   struct kref kref ;
   size_t len ;
   dma_addr_t addr[0U] ;
};
#line 445 "include/linux/dmaengine.h"
struct dma_async_tx_descriptor {
   dma_cookie_t cookie ;
   enum dma_ctrl_flags flags ;
   dma_addr_t phys ;
   struct dma_chan *chan ;
   dma_cookie_t (*tx_submit)(struct dma_async_tx_descriptor * ) ;
   void (*callback)(void * ) ;
   void *callback_param ;
   struct dmaengine_unmap_data *unmap ;
   struct dma_async_tx_descriptor *next ;
   struct dma_async_tx_descriptor *parent ;
   spinlock_t lock ;
};
#line 570 "include/linux/dmaengine.h"
struct dma_tx_state {
   dma_cookie_t last ;
   dma_cookie_t used ;
   u32 residue ;
};
#line 586 "include/linux/dmaengine.h"
struct dma_device {
   unsigned int chancnt ;
   unsigned int privatecnt ;
   struct list_head channels ;
   struct list_head global_node ;
   dma_cap_mask_t cap_mask ;
   unsigned short max_xor ;
   unsigned short max_pq ;
   u8 copy_align ;
   u8 xor_align ;
   u8 pq_align ;
   u8 fill_align ;
   int dev_id ;
   struct device *dev ;
   u32 src_addr_widths ;
   u32 dst_addr_widths ;
   u32 directions ;
   enum dma_residue_granularity residue_granularity ;
   int (*device_alloc_chan_resources)(struct dma_chan * ) ;
   void (*device_free_chan_resources)(struct dma_chan * ) ;
   struct dma_async_tx_descriptor *(*device_prep_dma_memcpy)(struct dma_chan * , dma_addr_t  ,
                                                             dma_addr_t  , size_t  ,
                                                             unsigned long  ) ;
   struct dma_async_tx_descriptor *(*device_prep_dma_xor)(struct dma_chan * , dma_addr_t  ,
                                                          dma_addr_t * , unsigned int  ,
                                                          size_t  , unsigned long  ) ;
   struct dma_async_tx_descriptor *(*device_prep_dma_xor_val)(struct dma_chan * ,
                                                              dma_addr_t * , unsigned int  ,
                                                              size_t  , enum sum_check_flags * ,
                                                              unsigned long  ) ;
   struct dma_async_tx_descriptor *(*device_prep_dma_pq)(struct dma_chan * , dma_addr_t * ,
                                                         dma_addr_t * , unsigned int  ,
                                                         unsigned char const   * ,
                                                         size_t  , unsigned long  ) ;
   struct dma_async_tx_descriptor *(*device_prep_dma_pq_val)(struct dma_chan * , dma_addr_t * ,
                                                             dma_addr_t * , unsigned int  ,
                                                             unsigned char const   * ,
                                                             size_t  , enum sum_check_flags * ,
                                                             unsigned long  ) ;
   struct dma_async_tx_descriptor *(*device_prep_dma_memset)(struct dma_chan * , dma_addr_t  ,
                                                             int  , size_t  , unsigned long  ) ;
   struct dma_async_tx_descriptor *(*device_prep_dma_interrupt)(struct dma_chan * ,
                                                                unsigned long  ) ;
   struct dma_async_tx_descriptor *(*device_prep_dma_sg)(struct dma_chan * , struct scatterlist * ,
                                                         unsigned int  , struct scatterlist * ,
                                                         unsigned int  , unsigned long  ) ;
   struct dma_async_tx_descriptor *(*device_prep_slave_sg)(struct dma_chan * , struct scatterlist * ,
                                                           unsigned int  , enum dma_transfer_direction  ,
                                                           unsigned long  , void * ) ;
   struct dma_async_tx_descriptor *(*device_prep_dma_cyclic)(struct dma_chan * , dma_addr_t  ,
                                                             size_t  , size_t  , enum dma_transfer_direction  ,
                                                             unsigned long  ) ;
   struct dma_async_tx_descriptor *(*device_prep_interleaved_dma)(struct dma_chan * ,
                                                                  struct dma_interleaved_template * ,
                                                                  unsigned long  ) ;
   int (*device_config)(struct dma_chan * , struct dma_slave_config * ) ;
   int (*device_pause)(struct dma_chan * ) ;
   int (*device_resume)(struct dma_chan * ) ;
   int (*device_terminate_all)(struct dma_chan * ) ;
   enum dma_status (*device_tx_status)(struct dma_chan * , dma_cookie_t  , struct dma_tx_state * ) ;
   void (*device_issue_pending)(struct dma_chan * ) ;
};
#line 87 "include/linux/rio.h"
struct rio_mport;
#line 88
struct rio_dev;
#line 89
union rio_pw_msg;
#line 90
struct rio_switch_ops;
#line 90 "include/linux/rio.h"
struct rio_switch {
   struct list_head node ;
   u8 *route_table ;
   u32 port_ok ;
   struct rio_switch_ops *ops ;
   spinlock_t lock ;
   struct rio_dev *nextdev[0U] ;
};
#line 109 "include/linux/rio.h"
struct rio_switch_ops {
   struct module *owner ;
   int (*add_entry)(struct rio_mport * , u16  , u8  , u16  , u16  , u8  ) ;
   int (*get_entry)(struct rio_mport * , u16  , u8  , u16  , u16  , u8 * ) ;
   int (*clr_table)(struct rio_mport * , u16  , u8  , u16  ) ;
   int (*set_domain)(struct rio_mport * , u16  , u8  , u8  ) ;
   int (*get_domain)(struct rio_mport * , u16  , u8  , u8 * ) ;
   int (*em_init)(struct rio_dev * ) ;
   int (*em_handle)(struct rio_dev * , u8  ) ;
};
#line 139
struct rio_net;
#line 139
struct rio_driver;
#line 139 "include/linux/rio.h"
struct rio_dev {
   struct list_head global_list ;
   struct list_head net_list ;
   struct rio_net *net ;
   bool do_enum ;
   u16 did ;
   u16 vid ;
   u32 device_rev ;
   u16 asm_did ;
   u16 asm_vid ;
   u16 asm_rev ;
   u16 efptr ;
   u32 pef ;
   u32 swpinfo ;
   u32 src_ops ;
   u32 dst_ops ;
   u32 comp_tag ;
   u32 phys_efptr ;
   u32 em_efptr ;
   u64 dma_mask ;
   struct rio_driver *driver ;
   struct device dev ;
   struct resource riores[16U] ;
   int (*pwcback)(struct rio_dev * , union rio_pw_msg * , int  ) ;
   u16 destid ;
   u8 hopcount ;
   struct rio_dev *prev ;
   struct rio_switch rswitch[0U] ;
};
#line 199 "include/linux/rio.h"
struct rio_msg {
   struct resource *res ;
   void (*mcback)(struct rio_mport * , void * , int  , int  ) ;
};
#line 229
enum rio_phy_type {
    RIO_PHY_PARALLEL = 0,
    RIO_PHY_SERIAL = 1
} ;
#line 234
struct rio_ops;
#line 234
struct rio_scan;
#line 234 "include/linux/rio.h"
struct rio_mport {
   struct list_head dbells ;
   struct list_head node ;
   struct list_head nnode ;
   struct resource iores ;
   struct resource riores[16U] ;
   struct rio_msg inb_msg[4U] ;
   struct rio_msg outb_msg[4U] ;
   int host_deviceid ;
   struct rio_ops *ops ;
   unsigned char id ;
   unsigned char index ;
   unsigned int sys_size ;
   enum rio_phy_type phy_type ;
   u32 phys_efptr ;
   unsigned char name[40U] ;
   struct device dev ;
   void *priv ;
   struct dma_device dma ;
   struct rio_scan *nscan ;
};
#line 284 "include/linux/rio.h"
struct rio_id_table {
   u16 start ;
   u32 max ;
   spinlock_t lock ;
   unsigned long *table ;
};
#line 296 "include/linux/rio.h"
struct rio_net {
   struct list_head node ;
   struct list_head devices ;
   struct list_head switches ;
   struct list_head mports ;
   struct rio_mport *hport ;
   unsigned char id ;
   struct rio_id_table destid_table ;
};
#line 316 "include/linux/rio.h"
struct rio_ops {
   int (*lcread)(struct rio_mport * , int  , u32  , int  , u32 * ) ;
   int (*lcwrite)(struct rio_mport * , int  , u32  , int  , u32  ) ;
   int (*cread)(struct rio_mport * , int  , u16  , u8  , u32  , int  , u32 * ) ;
   int (*cwrite)(struct rio_mport * , int  , u16  , u8  , u32  , int  , u32  ) ;
   int (*dsend)(struct rio_mport * , int  , u16  , u16  ) ;
   int (*pwenable)(struct rio_mport * , int  ) ;
   int (*open_outb_mbox)(struct rio_mport * , void * , int  , int  ) ;
   void (*close_outb_mbox)(struct rio_mport * , int  ) ;
   int (*open_inb_mbox)(struct rio_mport * , void * , int  , int  ) ;
   void (*close_inb_mbox)(struct rio_mport * , int  ) ;
   int (*add_outb_message)(struct rio_mport * , struct rio_dev * , int  , void * ,
                           size_t  ) ;
   int (*add_inb_buffer)(struct rio_mport * , int  , void * ) ;
   void *(*get_inb_message)(struct rio_mport * , int  ) ;
   int (*map_inb)(struct rio_mport * , dma_addr_t  , u64  , u32  , u32  ) ;
   void (*unmap_inb)(struct rio_mport * , dma_addr_t  ) ;
};
#line 362 "include/linux/rio.h"
struct rio_driver {
   struct list_head node ;
   char *name ;
   struct rio_device_id  const  *id_table ;
   int (*probe)(struct rio_dev * , struct rio_device_id  const  * ) ;
   void (*remove)(struct rio_dev * ) ;
   int (*suspend)(struct rio_dev * , u32  ) ;
   int (*resume)(struct rio_dev * ) ;
   int (*enable_wake)(struct rio_dev * , u32  , int  ) ;
   struct device_driver driver ;
};
#line 398 "include/linux/rio.h"
struct __anonstruct_em_173 {
   u32 comptag ;
   u32 errdetect ;
   u32 is_port ;
   u32 ltlerrdet ;
   u32 padding[12U] ;
};
#line 398 "include/linux/rio.h"
union rio_pw_msg {
   struct __anonstruct_em_173 em ;
   u32 raw[16U] ;
};
#line 452 "include/linux/rio.h"
struct rio_scan {
   struct module *owner ;
   int (*enumerate)(struct rio_mport * , u32  ) ;
   int (*discover)(struct rio_mport * , u32  ) ;
};
#line 15 "include/uapi/linux/elf.h"
typedef __u64 Elf64_Addr;
#line 16 "include/uapi/linux/elf.h"
typedef __u16 Elf64_Half;
#line 20 "include/uapi/linux/elf.h"
typedef __u32 Elf64_Word;
#line 21 "include/uapi/linux/elf.h"
typedef __u64 Elf64_Xword;
#line 190 "include/uapi/linux/elf.h"
struct elf64_sym {
   Elf64_Word st_name ;
   unsigned char st_info ;
   unsigned char st_other ;
   Elf64_Half st_shndx ;
   Elf64_Addr st_value ;
   Elf64_Xword st_size ;
};
#line 198 "include/uapi/linux/elf.h"
typedef struct elf64_sym Elf64_Sym;
#line 53 "include/linux/elf.h"
struct kernel_param;
#line 58 "include/linux/elf.h"
struct kernel_param_ops {
   unsigned int flags ;
   int (*set)(char const   * , struct kernel_param  const  * ) ;
   int (*get)(char * , struct kernel_param  const  * ) ;
   void (*free)(void * ) ;
};
#line 62 "include/linux/moduleparam.h"
struct kparam_string;
#line 62
struct kparam_array;
#line 62 "include/linux/moduleparam.h"
union __anonunion____missing_field_name_178 {
   void *arg ;
   struct kparam_string  const  *str ;
   struct kparam_array  const  *arr ;
};
#line 62 "include/linux/moduleparam.h"
struct kernel_param {
   char const   *name ;
   struct module *mod ;
   struct kernel_param_ops  const  *ops ;
   u16 const   perm ;
   s8 level ;
   u8 flags ;
   union __anonunion____missing_field_name_178 __annonCompField50 ;
};
#line 83 "include/linux/moduleparam.h"
struct kparam_string {
   unsigned int maxlen ;
   char *string ;
};
#line 89 "include/linux/moduleparam.h"
struct kparam_array {
   unsigned int max ;
   unsigned int elemsize ;
   unsigned int *num ;
   struct kernel_param_ops  const  *ops ;
   void *elem ;
};
#line 469 "include/linux/moduleparam.h"
struct latch_tree_node {
   struct rb_node node[2U] ;
};
#line 211 "include/linux/rbtree_latch.h"
struct mod_arch_specific {

};
#line 37 "include/linux/module.h"
struct module_param_attrs;
#line 37 "include/linux/module.h"
struct module_kobject {
   struct kobject kobj ;
   struct module *mod ;
   struct kobject *drivers_dir ;
   struct module_param_attrs *mp ;
   struct completion *kobj_completion ;
};
#line 47 "include/linux/module.h"
struct module_attribute {
   struct attribute attr ;
   ssize_t (*show)(struct module_attribute * , struct module_kobject * , char * ) ;
   ssize_t (*store)(struct module_attribute * , struct module_kobject * , char const   * ,
                    size_t  ) ;
   void (*setup)(struct module * , char const   * ) ;
   int (*test)(struct module * ) ;
   void (*free)(struct module * ) ;
};
#line 73
struct exception_table_entry;
#line 206
enum module_state {
    MODULE_STATE_LIVE = 0,
    MODULE_STATE_COMING = 1,
    MODULE_STATE_GOING = 2,
    MODULE_STATE_UNFORMED = 3
} ;
#line 213 "include/linux/module.h"
struct mod_tree_node {
   struct module *mod ;
   struct latch_tree_node node ;
};
#line 220
struct module_sect_attrs;
#line 220
struct module_notes_attrs;
#line 220
struct tracepoint;
#line 220
struct trace_event_call;
#line 220
struct trace_enum_map;
#line 220 "include/linux/module.h"
struct module {
   enum module_state state ;
   struct list_head list ;
   char name[56U] ;
   struct module_kobject mkobj ;
   struct module_attribute *modinfo_attrs ;
   char const   *version ;
   char const   *srcversion ;
   struct kobject *holders_dir ;
   struct kernel_symbol  const  *syms ;
   unsigned long const   *crcs ;
   unsigned int num_syms ;
   struct mutex param_lock ;
   struct kernel_param *kp ;
   unsigned int num_kp ;
   unsigned int num_gpl_syms ;
   struct kernel_symbol  const  *gpl_syms ;
   unsigned long const   *gpl_crcs ;
   struct kernel_symbol  const  *unused_syms ;
   unsigned long const   *unused_crcs ;
   unsigned int num_unused_syms ;
   unsigned int num_unused_gpl_syms ;
   struct kernel_symbol  const  *unused_gpl_syms ;
   unsigned long const   *unused_gpl_crcs ;
   bool sig_ok ;
   bool async_probe_requested ;
   struct kernel_symbol  const  *gpl_future_syms ;
   unsigned long const   *gpl_future_crcs ;
   unsigned int num_gpl_future_syms ;
   unsigned int num_exentries ;
   struct exception_table_entry *extable ;
   int (*init)(void) ;
   void *module_init ;
   void *module_core ;
   unsigned int init_size ;
   unsigned int core_size ;
   unsigned int init_text_size ;
   unsigned int core_text_size ;
   struct mod_tree_node mtn_core ;
   struct mod_tree_node mtn_init ;
   unsigned int init_ro_size ;
   unsigned int core_ro_size ;
   struct mod_arch_specific arch ;
   unsigned int taints ;
   unsigned int num_bugs ;
   struct list_head bug_list ;
   struct bug_entry *bug_table ;
   Elf64_Sym *symtab ;
   Elf64_Sym *core_symtab ;
   unsigned int num_symtab ;
   unsigned int core_num_syms ;
   char *strtab ;
   char *core_strtab ;
   struct module_sect_attrs *sect_attrs ;
   struct module_notes_attrs *notes_attrs ;
   char *args ;
   void *percpu ;
   unsigned int percpu_size ;
   unsigned int num_tracepoints ;
   struct tracepoint * const  *tracepoints_ptrs ;
   unsigned int num_trace_bprintk_fmt ;
   char const   **trace_bprintk_fmt_start ;
   struct trace_event_call **trace_events ;
   unsigned int num_trace_events ;
   struct trace_enum_map **trace_enums ;
   unsigned int num_trace_enums ;
   bool klp_alive ;
   struct list_head source_list ;
   struct list_head target_list ;
   void (*exit)(void) ;
   atomic_t refcnt ;
   ctor_fn_t (**ctors)(void) ;
   unsigned int num_ctors ;
};
#line 96 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.o.c.prepared"
typedef int ldv_func_ret_type;
#line 1 "<compiler builtins>"
__inline static long ldv__builtin_expect(long exp , long c ) ;
#line 33 "include/linux/export.h"
extern struct module __this_module ;
#line 45 "include/linux/dynamic_debug.h"
extern void __dynamic_pr_debug(struct _ddebug * , char const   *  , ...) ;
#line 173 "include/linux/mutex.h"
extern int mutex_trylock(struct mutex * ) ;
#line 176
int ldv_mutex_trylock_8(struct mutex *ldv_func_arg1 ) ;
#line 178
extern void mutex_unlock(struct mutex * ) ;
#line 181
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) ;
#line 185
void ldv_mutex_unlock_9(struct mutex *ldv_func_arg1 ) ;
#line 50 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static long ldv__builtin_expect(long exp , long c ) 
{ 


  {
#line 52
  return (exp);
}
}
#line 18 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.o.c.prepared"
extern void mutex_lock(struct mutex * ) ;
#line 21
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) ;
#line 25
void ldv_mutex_lock_7(struct mutex *ldv_func_arg1 ) ;
#line 30
void ldv_mutex_lock_lock(struct mutex *lock ) ;
#line 34
void ldv_mutex_unlock_lock(struct mutex *lock ) ;
#line 43
void ldv_mutex_lock_mutex_of_device(struct mutex *lock ) ;
#line 44
int ldv_mutex_trylock_mutex_of_device(struct mutex *lock ) ;
#line 47
void ldv_mutex_unlock_mutex_of_device(struct mutex *lock ) ;
#line 22 "include/linux/spinlock_api_smp.h"
extern void _raw_spin_lock(raw_spinlock_t * ) ;
#line 41
extern void _raw_spin_unlock(raw_spinlock_t * ) ;
#line 310 "include/linux/spinlock.h"
__inline static void spin_lock(spinlock_t *lock ) 
{ 


  {
#line 312
  _raw_spin_lock(& lock->__annonCompField17.rlock);
#line 313
  return;
}
}
#line 355 "include/linux/spinlock.h"
__inline static void spin_unlock(spinlock_t *lock ) 
{ 


  {
#line 357
  _raw_spin_unlock(& lock->__annonCompField17.rlock);
#line 358
  return;
}
}
#line 86 "include/linux/kobject.h"
__inline static char const   *kobject_name(struct kobject  const  *kobj ) 
{ 


  {
#line 88
  return ((char const   *)kobj->name);
}
}
#line 832 "include/linux/device.h"
__inline static char const   *dev_name(struct device  const  *dev ) 
{ 
  char const   *tmp ;

  {
#line 835
  if ((unsigned long )dev->init_name != (unsigned long )((char const   */* const  */)0)) {
#line 836
    return ((char const   *)dev->init_name);
  } else {

  }
#line 838
  tmp = kobject_name(& dev->kobj);
#line 838
  return (tmp);
}
}
#line 36 "include/linux/rio_drv.h"
extern int rio_mport_read_config_32(struct rio_mport * , u16  , u8  , u32  , u32 * ) ;
#line 38
extern int rio_mport_write_config_32(struct rio_mport * , u16  , u8  , u32  , u32  ) ;
#line 149 "include/linux/rio_drv.h"
__inline static int rio_read_config_32(struct rio_dev *rdev , u32 offset , u32 *data ) 
{ 
  int tmp ;

  {
#line 152
  tmp = rio_mport_read_config_32((rdev->net)->hport, (int )rdev->destid, (int )rdev->hopcount,
                                 offset, data);
#line 152
  return (tmp);
}
}
#line 165 "include/linux/rio_drv.h"
__inline static int rio_write_config_32(struct rio_dev *rdev , u32 offset , u32 data ) 
{ 
  int tmp ;

  {
#line 168
  tmp = rio_mport_write_config_32((rdev->net)->hport, (int )rdev->destid, (int )rdev->hopcount,
                                  offset, data);
#line 168
  return (tmp);
}
}
#line 381
extern void rio_unregister_driver(struct rio_driver * ) ;
#line 406 "include/linux/rio_drv.h"
__inline static char const   *rio_name(struct rio_dev *rdev ) 
{ 
  char const   *tmp ;

  {
#line 408
  tmp = dev_name((struct device  const  *)(& rdev->dev));
#line 408
  return (tmp);
}
}
#line 10 "include/asm-generic/delay.h"
extern void __const_udelay(unsigned long  ) ;
#line 47 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static int tsi57x_route_add_entry(struct rio_mport *mport , u16 destid , u8 hopcount ,
                                  u16 table , u16 route_destid , u8 route_port ) 
{ 


  {
#line 50
  if ((unsigned int )table == 255U) {
#line 51
    rio_mport_write_config_32(mport, (int )destid, (int )hopcount, 65648U, (u32 )route_destid);
#line 53
    rio_mport_write_config_32(mport, (int )destid, (int )hopcount, 65652U, (u32 )route_port);
  } else {
#line 56
    rio_mport_write_config_32(mport, (int )destid, (int )hopcount, (u32 )((int )table * 256 + 69744),
                              (u32 )route_destid);
#line 58
    rio_mport_write_config_32(mport, (int )destid, (int )hopcount, (u32 )((int )table * 256 + 69748),
                              (u32 )route_port);
  }
#line 62
  __const_udelay(42950UL);
#line 64
  return (0);
}
}
#line 68 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static int tsi57x_route_get_entry(struct rio_mport *mport , u16 destid , u8 hopcount ,
                                  u16 table , u16 route_destid , u8 *route_port ) 
{ 
  int ret ;
  u32 result ;

  {
#line 71
  ret = 0;
#line 74
  if ((unsigned int )table == 255U) {
#line 77
    rio_mport_read_config_32(mport, (int )destid, (int )hopcount, 20U, & result);
#line 79
    table = (unsigned int )((u16 )result) & 255U;
  } else {

  }
#line 82
  rio_mport_write_config_32(mport, (int )destid, (int )hopcount, (u32 )((int )table * 256 + 69744),
                            (u32 )route_destid);
#line 84
  rio_mport_read_config_32(mport, (int )destid, (int )hopcount, (u32 )((int )table * 256 + 69748),
                           & result);
#line 87
  *route_port = (unsigned char )result;
#line 88
  if ((unsigned int )*route_port > 15U) {
#line 89
    ret = -1;
  } else {

  }
#line 91
  return (ret);
}
}
#line 95 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static int tsi57x_route_clr_table(struct rio_mport *mport , u16 destid , u8 hopcount ,
                                  u16 table ) 
{ 
  u32 route_idx ;
  u32 lut_size ;

  {
#line 101
  lut_size = mport->sys_size != 0U ? 511U : 255U;
#line 103
  if ((unsigned int )table == 255U) {
#line 104
    rio_mport_write_config_32(mport, (int )destid, (int )hopcount, 65648U, 2147483648U);
#line 106
    route_idx = 0U;
#line 106
    goto ldv_21922;
    ldv_21921: 
#line 107
    rio_mport_write_config_32(mport, (int )destid, (int )hopcount, 65652U, 255U);
#line 106
    route_idx = route_idx + 1U;
    ldv_21922: ;
#line 106
    if (route_idx <= lut_size) {
#line 108
      goto ldv_21921;
    } else {

    }

  } else {
#line 111
    rio_mport_write_config_32(mport, (int )destid, (int )hopcount, (u32 )((int )table * 256 + 69744),
                              2147483648U);
#line 113
    route_idx = 0U;
#line 113
    goto ldv_21925;
    ldv_21924: 
#line 114
    rio_mport_write_config_32(mport, (int )destid, (int )hopcount, (u32 )((int )table * 256 + 69748),
                              255U);
#line 113
    route_idx = route_idx + 1U;
    ldv_21925: ;
#line 113
    if (route_idx <= lut_size) {
#line 115
      goto ldv_21924;
    } else {

    }

  }
#line 118
  return (0);
}
}
#line 122 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static int tsi57x_set_domain(struct rio_mport *mport , u16 destid , u8 hopcount ,
                             u8 sw_domain ) 
{ 
  u32 regval ;

  {
#line 132
  rio_mport_read_config_32(mport, (int )destid, (int )hopcount, 65540U, & regval);
#line 134
  rio_mport_write_config_32(mport, (int )destid, (int )hopcount, 65540U, regval & 4278190079U);
#line 137
  rio_mport_write_config_32(mport, (int )destid, (int )hopcount, 65656U, (unsigned int )((int )sw_domain << 24));
#line 140
  return (0);
}
}
#line 144 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static int tsi57x_get_domain(struct rio_mport *mport , u16 destid , u8 hopcount ,
                             u8 *sw_domain ) 
{ 
  u32 regval ;

  {
#line 152
  rio_mport_read_config_32(mport, (int )destid, (int )hopcount, 65656U, & regval);
#line 155
  *sw_domain = (unsigned char )(regval >> 24);
#line 157
  return (0);
}
}
#line 161 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static int tsi57x_em_init(struct rio_dev *rdev ) 
{ 
  u32 regval ;
  int portnum ;
  struct _ddebug descriptor ;
  long tmp ;

  {
#line 166
  descriptor.modname = "tsi57x";
#line 166
  descriptor.function = "tsi57x_em_init";
#line 166
  descriptor.filename = "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c";
#line 166
  descriptor.format = "TSI578 %s [%d:%d]\n";
#line 166
  descriptor.lineno = 166U;
#line 166
  descriptor.flags = 0U;
#line 166
  tmp = ldv__builtin_expect((long )descriptor.flags & 1L, 0L);
#line 166
  if (tmp != 0L) {
#line 166
    __dynamic_pr_debug(& descriptor, "TSI578 %s [%d:%d]\n", "tsi57x_em_init", (int )rdev->destid,
                       (int )rdev->hopcount);
  } else {

  }
#line 168
  portnum = 0;
#line 168
  goto ldv_21949;
  ldv_21948: 
#line 171
  rio_read_config_32(rdev, (u32 )(portnum * 256 + 69636), & regval);
#line 173
  rio_write_config_32(rdev, (u32 )(portnum * 256 + 69636), regval & 4160749567U);
#line 178
  rio_read_config_32(rdev, (rdev->phys_efptr + (u32 )(portnum * 32)) + 88U, & regval);
#line 182
  rio_write_config_32(rdev, (rdev->phys_efptr + (u32 )(portnum * 32)) + 88U, regval & 118620692U);
#line 187
  rio_read_config_32(rdev, (u32 )(portnum * 256 + 77848), & regval);
#line 189
  rio_write_config_32(rdev, (u32 )(portnum * 256 + 77848), regval & 458941U);
#line 194
  rio_read_config_32(rdev, (u32 )(portnum * 256 + 77828), & regval);
#line 196
  rio_write_config_32(rdev, (u32 )(portnum * 256 + 77828), regval | 720896U);
#line 201
  rio_read_config_32(rdev, (rdev->phys_efptr + (u32 )(portnum * 32)) + 92U, & regval);
#line 204
  if ((regval & 3221225472U) == 1073741824U) {
#line 205
    portnum = portnum + 1;
  } else {

  }
#line 169
  portnum = portnum + 1;
  ldv_21949: ;
#line 168
  if ((u32 )portnum < (rdev->swpinfo & 65280U) >> 8) {
#line 171
    goto ldv_21948;
  } else {

  }
#line 209
  rio_write_config_32(rdev, rdev->phys_efptr + 32U, 39424U);
#line 212
  return (0);
}
}
#line 216 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static int tsi57x_em_handler(struct rio_dev *rdev , u8 portnum ) 
{ 
  struct rio_mport *mport ;
  u32 intstat ;
  u32 err_status ;
  int sendcount ;
  int checkcount ;
  u8 route_port ;
  u32 regval ;
  int tmp ;
  struct _ddebug descriptor ;
  long tmp___0 ;
  struct _ddebug descriptor___0 ;
  char const   *tmp___1 ;
  long tmp___2 ;

  {
#line 218
  mport = (rdev->net)->hport;
#line 224
  rio_read_config_32(rdev, (rdev->phys_efptr + (u32 )((int )portnum * 32)) + 88U,
                     & err_status);
#line 228
  if ((err_status & 2U) != 0U && (err_status & 65792U) != 0U) {
#line 232
    rio_read_config_32(rdev, (rdev->phys_efptr + (u32 )((int )portnum * 32)) + 92U,
                       & regval);
#line 235
    if ((regval & 2U) == 0U) {
#line 236
      rio_write_config_32(rdev, (rdev->phys_efptr + (u32 )((int )portnum * 32)) + 92U,
                          regval | 2U);
#line 239
      __const_udelay(214750UL);
#line 240
      rio_write_config_32(rdev, (rdev->phys_efptr + (u32 )((int )portnum * 32)) + 92U,
                          regval);
    } else {

    }
#line 248
    rio_read_config_32(rdev, (rdev->phys_efptr + (u32 )((int )portnum * 32)) + 68U,
                       & regval);
#line 255
    sendcount = 3;
#line 256
    goto ldv_21967;
    ldv_21966: 
#line 257
    rio_write_config_32(rdev, (u32 )((int )portnum * 256 + 77844), 1090289664U);
#line 259
    checkcount = 3;
#line 260
    goto ldv_21964;
    ldv_21963: 
#line 261
    __const_udelay(214750UL);
#line 262
    rio_read_config_32(rdev, (rdev->phys_efptr + (u32 )((int )portnum * 32)) + 68U,
                       & regval);
#line 266
    if ((int )regval < 0) {
#line 267
      goto exit_es;
    } else {

    }
    ldv_21964: 
#line 260
    tmp = checkcount;
#line 260
    checkcount = checkcount - 1;
#line 260
    if (tmp != 0) {
#line 262
      goto ldv_21963;
    } else {

    }
#line 270
    sendcount = sendcount - 1;
    ldv_21967: ;
#line 256
    if (sendcount != 0) {
#line 258
      goto ldv_21966;
    } else {

    }

  } else {

  }
  exit_es: 
#line 276
  rio_read_config_32(rdev, (u32 )((int )portnum * 256 + 77848), & intstat);
#line 277
  descriptor.modname = "tsi57x";
#line 277
  descriptor.function = "tsi57x_em_handler";
#line 277
  descriptor.filename = "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c";
#line 277
  descriptor.format = "TSI578[%x:%x] SP%d_INT_STATUS=0x%08x\n";
#line 277
  descriptor.lineno = 278U;
#line 277
  descriptor.flags = 0U;
#line 277
  tmp___0 = ldv__builtin_expect((long )descriptor.flags & 1L, 0L);
#line 277
  if (tmp___0 != 0L) {
#line 277
    __dynamic_pr_debug(& descriptor, "TSI578[%x:%x] SP%d_INT_STATUS=0x%08x\n", (int )rdev->destid,
                       (int )rdev->hopcount, (int )portnum, intstat);
  } else {

  }
#line 280
  if ((intstat & 65536U) != 0U) {
#line 281
    rio_read_config_32(rdev, (u32 )((int )portnum * 256 + 77840), & regval);
#line 283
    regval = mport->sys_size != 0U ? regval >> 16 : regval >> 24;
#line 284
    route_port = *(((struct rio_switch *)(& rdev->rswitch))->route_table + (unsigned long )regval);
#line 285
    descriptor___0.modname = "tsi57x";
#line 285
    descriptor___0.function = "tsi57x_em_handler";
#line 285
    descriptor___0.filename = "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c";
#line 285
    descriptor___0.format = "RIO: TSI578[%s] P%d LUT Parity Error (destID=%d)\n";
#line 285
    descriptor___0.lineno = 286U;
#line 285
    descriptor___0.flags = 0U;
#line 285
    tmp___2 = ldv__builtin_expect((long )descriptor___0.flags & 1L, 0L);
#line 285
    if (tmp___2 != 0L) {
#line 285
      tmp___1 = rio_name(rdev);
#line 285
      __dynamic_pr_debug(& descriptor___0, "RIO: TSI578[%s] P%d LUT Parity Error (destID=%d)\n",
                         tmp___1, (int )portnum, regval);
    } else {

    }
#line 287
    tsi57x_route_add_entry(mport, (int )rdev->destid, (int )rdev->hopcount, 255, (int )((u16 )regval),
                           (int )route_port);
  } else {

  }
#line 291
  rio_write_config_32(rdev, (u32 )((int )portnum * 256 + 77848), intstat & 458941U);
#line 294
  return (0);
}
}
#line 297 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static struct rio_switch_ops tsi57x_switch_ops  = 
#line 297
     {& __this_module, & tsi57x_route_add_entry, & tsi57x_route_get_entry, & tsi57x_route_clr_table,
    & tsi57x_set_domain, & tsi57x_get_domain, & tsi57x_em_init, & tsi57x_em_handler};
#line 308 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static int tsi57x_probe(struct rio_dev *rdev , struct rio_device_id  const  *id ) 
{ 
  struct _ddebug descriptor ;
  char const   *tmp ;
  long tmp___0 ;

  {
#line 310
  descriptor.modname = "tsi57x";
#line 310
  descriptor.function = "tsi57x_probe";
#line 310
  descriptor.filename = "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c";
#line 310
  descriptor.format = "RIO: %s for %s\n";
#line 310
  descriptor.lineno = 310U;
#line 310
  descriptor.flags = 0U;
#line 310
  tmp___0 = ldv__builtin_expect((long )descriptor.flags & 1L, 0L);
#line 310
  if (tmp___0 != 0L) {
#line 310
    tmp = rio_name(rdev);
#line 310
    __dynamic_pr_debug(& descriptor, "RIO: %s for %s\n", "tsi57x_probe", tmp);
  } else {

  }
#line 312
  spin_lock(& ((struct rio_switch *)(& rdev->rswitch))->lock);
#line 314
  if ((unsigned long )((struct rio_switch *)(& rdev->rswitch))->ops != (unsigned long )((struct rio_switch_ops *)0)) {
#line 315
    spin_unlock(& ((struct rio_switch *)(& rdev->rswitch))->lock);
#line 316
    return (-22);
  } else {

  }
#line 318
  ((struct rio_switch *)(& rdev->rswitch))->ops = & tsi57x_switch_ops;
#line 320
  if ((int )rdev->do_enum) {
#line 322
    rio_write_config_32(rdev, 120U, 255U);
  } else {

  }
#line 326
  spin_unlock(& ((struct rio_switch *)(& rdev->rswitch))->lock);
#line 327
  return (0);
}
}
#line 330 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static void tsi57x_remove(struct rio_dev *rdev ) 
{ 
  struct _ddebug descriptor ;
  char const   *tmp ;
  long tmp___0 ;

  {
#line 332
  descriptor.modname = "tsi57x";
#line 332
  descriptor.function = "tsi57x_remove";
#line 332
  descriptor.filename = "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c";
#line 332
  descriptor.format = "RIO: %s for %s\n";
#line 332
  descriptor.lineno = 332U;
#line 332
  descriptor.flags = 0U;
#line 332
  tmp___0 = ldv__builtin_expect((long )descriptor.flags & 1L, 0L);
#line 332
  if (tmp___0 != 0L) {
#line 332
    tmp = rio_name(rdev);
#line 332
    __dynamic_pr_debug(& descriptor, "RIO: %s for %s\n", "tsi57x_remove", tmp);
  } else {

  }
#line 333
  spin_lock(& ((struct rio_switch *)(& rdev->rswitch))->lock);
#line 334
  if ((unsigned long )((struct rio_switch *)(& rdev->rswitch))->ops != (unsigned long )(& tsi57x_switch_ops)) {
#line 335
    spin_unlock(& ((struct rio_switch *)(& rdev->rswitch))->lock);
#line 336
    return;
  } else {

  }
#line 338
  ((struct rio_switch *)(& rdev->rswitch))->ops = (struct rio_switch_ops *)0;
#line 339
  spin_unlock(& ((struct rio_switch *)(& rdev->rswitch))->lock);
#line 340
  return;
}
}
#line 342 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static struct rio_device_id tsi57x_id_table[5U]  = {      {1394U, 13U, 65535U, 65535U}, 
        {1396U, 13U, 65535U, 65535U}, 
        {1399U, 13U, 65535U, 65535U}, 
        {1400U, 13U, 65535U, 65535U}, 
        {0U, (unsigned short)0, (unsigned short)0, (unsigned short)0}};
#line 350 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static struct rio_driver tsi57x_driver  = 
#line 350
     {{0, 0}, (char *)"tsi57x", (struct rio_device_id  const  *)(& tsi57x_id_table),
    & tsi57x_probe, & tsi57x_remove, 0, 0, 0, {0, 0, 0, 0, (_Bool)0, 0, 0, 0, 0, 0,
                                               0, 0, 0, 0, 0, 0}};
#line 362 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
static void tsi57x_exit(void) 
{ 


  {
#line 364
  rio_unregister_driver(& tsi57x_driver);
#line 365
  return;
}
}
#line 390
void ldv_check_final_state(void) ;
#line 393
extern void ldv_check_return_value(int  ) ;
#line 396
extern void ldv_check_return_value_probe(int  ) ;
#line 399
extern void ldv_initialize(void) ;
#line 402
extern void ldv_handler_precall(void) ;
#line 405
extern int nondet_int(void) ;
#line 408 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
int LDV_IN_INTERRUPT  ;
#line 411 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.c"
void main(void) 
{ 
  struct rio_mport *var_group1 ;
  u16 var_tsi57x_route_add_entry_0_p1 ;
  u8 var_tsi57x_route_add_entry_0_p2 ;
  u16 var_tsi57x_route_add_entry_0_p3 ;
  u16 var_tsi57x_route_add_entry_0_p4 ;
  u8 var_tsi57x_route_add_entry_0_p5 ;
  u16 var_tsi57x_route_get_entry_1_p1 ;
  u8 var_tsi57x_route_get_entry_1_p2 ;
  u16 var_tsi57x_route_get_entry_1_p3 ;
  u16 var_tsi57x_route_get_entry_1_p4 ;
  u8 *var_tsi57x_route_get_entry_1_p5 ;
  u16 var_tsi57x_route_clr_table_2_p1 ;
  u8 var_tsi57x_route_clr_table_2_p2 ;
  u16 var_tsi57x_route_clr_table_2_p3 ;
  u16 var_tsi57x_set_domain_3_p1 ;
  u8 var_tsi57x_set_domain_3_p2 ;
  u8 var_tsi57x_set_domain_3_p3 ;
  u16 var_tsi57x_get_domain_4_p1 ;
  u8 var_tsi57x_get_domain_4_p2 ;
  u8 *var_tsi57x_get_domain_4_p3 ;
  struct rio_dev *var_group2 ;
  u8 var_tsi57x_em_handler_6_p1 ;
  struct rio_device_id  const  *var_tsi57x_probe_7_p1 ;
  int res_tsi57x_probe_7 ;
  int ldv_s_tsi57x_driver_rio_driver ;
  int tmp ;
  int tmp___0 ;

  {
#line 631
  ldv_s_tsi57x_driver_rio_driver = 0;
#line 619
  LDV_IN_INTERRUPT = 1;
#line 628
  ldv_initialize();
#line 634
  goto ldv_22059;
  ldv_22058: 
#line 638
  tmp = nondet_int();
#line 638
  switch (tmp) {
  case 0: 
#line 662
  ldv_handler_precall();
#line 663
  tsi57x_route_add_entry(var_group1, (int )var_tsi57x_route_add_entry_0_p1, (int )var_tsi57x_route_add_entry_0_p2,
                         (int )var_tsi57x_route_add_entry_0_p3, (int )var_tsi57x_route_add_entry_0_p4,
                         (int )var_tsi57x_route_add_entry_0_p5);
#line 670
  goto ldv_22047;
  case 1: 
#line 693
  ldv_handler_precall();
#line 694
  tsi57x_route_get_entry(var_group1, (int )var_tsi57x_route_get_entry_1_p1, (int )var_tsi57x_route_get_entry_1_p2,
                         (int )var_tsi57x_route_get_entry_1_p3, (int )var_tsi57x_route_get_entry_1_p4,
                         var_tsi57x_route_get_entry_1_p5);
#line 701
  goto ldv_22047;
  case 2: 
#line 724
  ldv_handler_precall();
#line 725
  tsi57x_route_clr_table(var_group1, (int )var_tsi57x_route_clr_table_2_p1, (int )var_tsi57x_route_clr_table_2_p2,
                         (int )var_tsi57x_route_clr_table_2_p3);
#line 732
  goto ldv_22047;
  case 3: 
#line 755
  ldv_handler_precall();
#line 756
  tsi57x_set_domain(var_group1, (int )var_tsi57x_set_domain_3_p1, (int )var_tsi57x_set_domain_3_p2,
                    (int )var_tsi57x_set_domain_3_p3);
#line 763
  goto ldv_22047;
  case 4: 
#line 786
  ldv_handler_precall();
#line 787
  tsi57x_get_domain(var_group1, (int )var_tsi57x_get_domain_4_p1, (int )var_tsi57x_get_domain_4_p2,
                    var_tsi57x_get_domain_4_p3);
#line 794
  goto ldv_22047;
  case 5: 
#line 817
  ldv_handler_precall();
#line 818
  tsi57x_em_init(var_group2);
#line 825
  goto ldv_22047;
  case 6: 
#line 848
  ldv_handler_precall();
#line 849
  tsi57x_em_handler(var_group2, (int )var_tsi57x_em_handler_6_p1);
#line 856
  goto ldv_22047;
  case 7: ;
#line 860
  if (ldv_s_tsi57x_driver_rio_driver == 0) {
#line 879
    res_tsi57x_probe_7 = tsi57x_probe(var_group2, var_tsi57x_probe_7_p1);
#line 880
    ldv_check_return_value(res_tsi57x_probe_7);
#line 881
    ldv_check_return_value_probe(res_tsi57x_probe_7);
#line 882
    if (res_tsi57x_probe_7 != 0) {
#line 883
      goto ldv_module_exit;
    } else {

    }
#line 884
    ldv_s_tsi57x_driver_rio_driver = ldv_s_tsi57x_driver_rio_driver + 1;
  } else {

  }
#line 890
  goto ldv_22047;
  case 8: ;
#line 894
  if (ldv_s_tsi57x_driver_rio_driver == 1) {
#line 913
    ldv_handler_precall();
#line 914
    tsi57x_remove(var_group2);
#line 915
    ldv_s_tsi57x_driver_rio_driver = 0;
  } else {

  }
#line 921
  goto ldv_22047;
  default: ;
#line 922
  goto ldv_22047;
  }
  ldv_22047: ;
  ldv_22059: 
#line 634
  tmp___0 = nondet_int();
#line 634
  if (tmp___0 != 0 || ldv_s_tsi57x_driver_rio_driver != 0) {
#line 637
    goto ldv_22058;
  } else {

  }

  ldv_module_exit: 
#line 948
  ldv_handler_precall();
#line 949
  tsi57x_exit();
#line 952
  ldv_check_final_state();
#line 955
  return;
}
}
#line 70 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.o.c.prepared"
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 73
  ldv_mutex_lock_lock(ldv_func_arg1);
#line 75
  mutex_lock(ldv_func_arg1);
#line 76
  return;
}
}
#line 78 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.o.c.prepared"
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 81
  ldv_mutex_unlock_lock(ldv_func_arg1);
#line 83
  mutex_unlock(ldv_func_arg1);
#line 84
  return;
}
}
#line 86 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.o.c.prepared"
void ldv_mutex_lock_7(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 89
  ldv_mutex_lock_mutex_of_device(ldv_func_arg1);
#line 91
  mutex_lock(ldv_func_arg1);
#line 92
  return;
}
}
#line 94 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.o.c.prepared"
int ldv_mutex_trylock_8(struct mutex *ldv_func_arg1 ) 
{ 
  ldv_func_ret_type ldv_func_res ;
  int tmp ;
  int tmp___0 ;

  {
#line 98
  tmp = mutex_trylock(ldv_func_arg1);
#line 98
  ldv_func_res = tmp;
#line 100
  tmp___0 = ldv_mutex_trylock_mutex_of_device(ldv_func_arg1);
#line 100
  return (tmp___0);
#line 102
  return (ldv_func_res);
}
}
#line 105 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/dscv/ri/32_7a/drivers/rapidio/switches/tsi57x.o.c.prepared"
void ldv_mutex_unlock_9(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 108
  ldv_mutex_unlock_mutex_of_device(ldv_func_arg1);
#line 110
  mutex_unlock(ldv_func_arg1);
#line 111
  return;
}
}
#line 10 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_error(void) 
{ 


  {
  ERROR: ;
#line 12
  goto ERROR;
}
}
#line 20 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_stop(void) 
{ 


  {
  LDV_STOP: ;
#line 21
  goto LDV_STOP;
}
}
#line 25
extern int ldv_undef_int(void) ;
#line 30 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static int ldv_undef_int_negative(void) 
{ 
  int ret ;
  int tmp ;

  {
#line 32
  tmp = ldv_undef_int();
#line 32
  ret = tmp;
#line 34
  if (ret >= 0) {
#line 34
    ldv_stop();
  } else {

  }
#line 36
  return (ret);
}
}
#line 7 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err(void const   *ptr ) 
{ 


  {
#line 10
  return ((unsigned long )ptr > 2012UL);
}
}
#line 14 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
void *ldv_err_ptr(long error ) 
{ 


  {
#line 17
  return ((void *)(2012L - error));
}
}
#line 21 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
long ldv_ptr_err(void const   *ptr ) 
{ 


  {
#line 24
  return ((long )(2012UL - (unsigned long )ptr));
}
}
#line 28 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err_or_null(void const   *ptr ) 
{ 
  bool tmp ;
  int tmp___0 ;

  {
#line 31
  if ((unsigned long )ptr == (unsigned long )((void const   *)0)) {
#line 31
    tmp___0 = 1;
  } else {
#line 31
    tmp = ldv_is_err(ptr);
#line 31
    if ((int )tmp) {
#line 31
      tmp___0 = 1;
    } else {
#line 31
      tmp___0 = 0;
    }
  }
#line 31
  return ((bool )tmp___0);
}
}
#line 8 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
static int ldv_mutex_lock  =    1;
#line 11 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_interruptible_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 16
  if (ldv_mutex_lock != 1) {
#line 16
    ldv_error();
  } else {

  }
#line 19
  nondetermined = ldv_undef_int();
#line 22
  if (nondetermined != 0) {
#line 25
    ldv_mutex_lock = 2;
#line 27
    return (0);
  } else {
#line 32
    return (-4);
  }
}
}
#line 37 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_killable_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 42
  if (ldv_mutex_lock != 1) {
#line 42
    ldv_error();
  } else {

  }
#line 45
  nondetermined = ldv_undef_int();
#line 48
  if (nondetermined != 0) {
#line 51
    ldv_mutex_lock = 2;
#line 53
    return (0);
  } else {
#line 58
    return (-4);
  }
}
}
#line 63 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_lock_lock(struct mutex *lock ) 
{ 


  {
#line 66
  if (ldv_mutex_lock != 1) {
#line 66
    ldv_error();
  } else {

  }
#line 68
  ldv_mutex_lock = 2;
#line 69
  return;
}
}
#line 72 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_trylock_lock(struct mutex *lock ) 
{ 
  int is_mutex_held_by_another_thread ;

  {
#line 77
  if (ldv_mutex_lock != 1) {
#line 77
    ldv_error();
  } else {

  }
#line 80
  is_mutex_held_by_another_thread = ldv_undef_int();
#line 83
  if (is_mutex_held_by_another_thread != 0) {
#line 86
    return (0);
  } else {
#line 91
    ldv_mutex_lock = 2;
#line 93
    return (1);
  }
}
}
#line 98 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_atomic_dec_and_mutex_lock_lock(atomic_t *cnt , struct mutex *lock ) 
{ 
  int atomic_value_after_dec ;

  {
#line 103
  if (ldv_mutex_lock != 1) {
#line 103
    ldv_error();
  } else {

  }
#line 106
  atomic_value_after_dec = ldv_undef_int();
#line 109
  if (atomic_value_after_dec == 0) {
#line 112
    ldv_mutex_lock = 2;
#line 114
    return (1);
  } else {

  }
#line 118
  return (0);
}
}
#line 123 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_is_locked_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 127
  if (ldv_mutex_lock == 1) {
#line 130
    nondetermined = ldv_undef_int();
#line 133
    if (nondetermined != 0) {
#line 136
      return (0);
    } else {
#line 141
      return (1);
    }
  } else {
#line 147
    return (1);
  }
}
}
#line 152 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_unlock_lock(struct mutex *lock ) 
{ 


  {
#line 155
  if (ldv_mutex_lock != 2) {
#line 155
    ldv_error();
  } else {

  }
#line 157
  ldv_mutex_lock = 1;
#line 158
  return;
}
}
#line 163 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_lock_device_lock(void) 
{ 


  {
#line 166
  ldv_mutex_lock_lock((struct mutex *)0);
#line 167
  return;
}
}
#line 170 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_trylock_device_lock(void) 
{ 
  int tmp ;

  {
#line 172
  tmp = ldv_mutex_trylock_lock((struct mutex *)0);
#line 172
  return (tmp);
}
}
#line 176 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_lock_device_for_reset_lock(void) 
{ 
  int tmp ;
  int tmp___0 ;

  {
#line 178
  tmp___0 = ldv_undef_int();
#line 178
  if (tmp___0 != 0) {
#line 180
    ldv_mutex_lock_lock((struct mutex *)0);
#line 182
    return (0);
  } else {
#line 185
    tmp = ldv_undef_int_negative();
#line 185
    return (tmp);
  }
}
}
#line 189 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_unlock_device_lock(void) 
{ 


  {
#line 191
  ldv_mutex_unlock_lock((struct mutex *)0);
#line 192
  return;
}
}
#line 194 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
static int ldv_mutex_mutex_of_device  =    1;
#line 197 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_interruptible_mutex_of_device(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 202
  if (ldv_mutex_mutex_of_device != 1) {
#line 202
    ldv_error();
  } else {

  }
#line 205
  nondetermined = ldv_undef_int();
#line 208
  if (nondetermined != 0) {
#line 211
    ldv_mutex_mutex_of_device = 2;
#line 213
    return (0);
  } else {
#line 218
    return (-4);
  }
}
}
#line 223 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_killable_mutex_of_device(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 228
  if (ldv_mutex_mutex_of_device != 1) {
#line 228
    ldv_error();
  } else {

  }
#line 231
  nondetermined = ldv_undef_int();
#line 234
  if (nondetermined != 0) {
#line 237
    ldv_mutex_mutex_of_device = 2;
#line 239
    return (0);
  } else {
#line 244
    return (-4);
  }
}
}
#line 249 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_lock_mutex_of_device(struct mutex *lock ) 
{ 


  {
#line 252
  if (ldv_mutex_mutex_of_device != 1) {
#line 252
    ldv_error();
  } else {

  }
#line 254
  ldv_mutex_mutex_of_device = 2;
#line 255
  return;
}
}
#line 258 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_trylock_mutex_of_device(struct mutex *lock ) 
{ 
  int is_mutex_held_by_another_thread ;

  {
#line 263
  if (ldv_mutex_mutex_of_device != 1) {
#line 263
    ldv_error();
  } else {

  }
#line 266
  is_mutex_held_by_another_thread = ldv_undef_int();
#line 269
  if (is_mutex_held_by_another_thread != 0) {
#line 272
    return (0);
  } else {
#line 277
    ldv_mutex_mutex_of_device = 2;
#line 279
    return (1);
  }
}
}
#line 284 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_atomic_dec_and_mutex_lock_mutex_of_device(atomic_t *cnt , struct mutex *lock ) 
{ 
  int atomic_value_after_dec ;

  {
#line 289
  if (ldv_mutex_mutex_of_device != 1) {
#line 289
    ldv_error();
  } else {

  }
#line 292
  atomic_value_after_dec = ldv_undef_int();
#line 295
  if (atomic_value_after_dec == 0) {
#line 298
    ldv_mutex_mutex_of_device = 2;
#line 300
    return (1);
  } else {

  }
#line 304
  return (0);
}
}
#line 309 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_is_locked_mutex_of_device(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 313
  if (ldv_mutex_mutex_of_device == 1) {
#line 316
    nondetermined = ldv_undef_int();
#line 319
    if (nondetermined != 0) {
#line 322
      return (0);
    } else {
#line 327
      return (1);
    }
  } else {
#line 333
    return (1);
  }
}
}
#line 338 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_unlock_mutex_of_device(struct mutex *lock ) 
{ 


  {
#line 341
  if (ldv_mutex_mutex_of_device != 2) {
#line 341
    ldv_error();
  } else {

  }
#line 343
  ldv_mutex_mutex_of_device = 1;
#line 344
  return;
}
}
#line 349 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_lock_device_mutex_of_device(void) 
{ 


  {
#line 352
  ldv_mutex_lock_mutex_of_device((struct mutex *)0);
#line 353
  return;
}
}
#line 356 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_trylock_device_mutex_of_device(void) 
{ 
  int tmp ;

  {
#line 358
  tmp = ldv_mutex_trylock_mutex_of_device((struct mutex *)0);
#line 358
  return (tmp);
}
}
#line 362 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_lock_device_for_reset_mutex_of_device(void) 
{ 
  int tmp ;
  int tmp___0 ;

  {
#line 364
  tmp___0 = ldv_undef_int();
#line 364
  if (tmp___0 != 0) {
#line 366
    ldv_mutex_lock_mutex_of_device((struct mutex *)0);
#line 368
    return (0);
  } else {
#line 371
    tmp = ldv_undef_int_negative();
#line 371
    return (tmp);
  }
}
}
#line 375 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_unlock_device_mutex_of_device(void) 
{ 


  {
#line 377
  ldv_mutex_unlock_mutex_of_device((struct mutex *)0);
#line 378
  return;
}
}
#line 382 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/6747/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_check_final_state(void) 
{ 


  {
#line 385
  if (ldv_mutex_lock != 1) {
#line 385
    ldv_error();
  } else {

  }
#line 387
  if (ldv_mutex_mutex_of_device != 1) {
#line 387
    ldv_error();
  } else {

  }
#line 391
  return;
}
}
